"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _OneNoteClient_instances, _OneNoteClient_client, _OneNoteClient_reporter, _OneNoteClient_getSections, _OneNoteClient_getSectionGroups, _OneNoteClient_getPages, _OneNoteClient_getPageContent, _OneNoteClient_processAll, _OneNoteClient_getAll, _OneNoteClient_resolveDataUrl, _OneNoteClient_handleError, _OneNoteClient_getParent;
Object.defineProperty(exports, "__esModule", { value: true });
exports.OneNoteClient = void 0;
const microsoft_graph_client_1 = require("@microsoft/microsoft-graph-client");
const content_1 = require("./content");
const defaultProperties = [
    "createdDateTime",
    "displayName",
    "lastModifiedDateTime",
    "id",
];
class OneNoteClient {
    constructor(authConfig, reporter) {
        _OneNoteClient_instances.add(this);
        _OneNoteClient_client.set(this, void 0);
        _OneNoteClient_reporter.set(this, void 0);
        __classPrivateFieldSet(this, _OneNoteClient_reporter, reporter, "f");
        __classPrivateFieldSet(this, _OneNoteClient_client, microsoft_graph_client_1.Client.init({
            authProvider: (done) => __awaiter(this, void 0, void 0, function* () {
                if ("window" in global) {
                    const { authenticate } = yield Promise.resolve().then(() => __importStar(require("./auth/browser")));
                    const result = yield authenticate(authConfig);
                    if (result)
                        done(null, result.accessToken);
                    else
                        done("Could not get access token", null);
                }
                else {
                    const { authenticate } = yield Promise.resolve().then(() => __importStar(require("./auth/node")));
                    const result = yield authenticate(authConfig);
                    if (result)
                        done(null, result.accessToken);
                    else
                        done("Could not get access token", null);
                }
            }),
        }), "f");
    }
    getNotebooks() {
        return __awaiter(this, void 0, void 0, function* () {
            let notebooks = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getAll).call(this, `/me/onenote/notebooks`, "notebook", defaultProperties);
            return yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_processAll).call(this, notebooks, "notebook", (notebook) => __awaiter(this, void 0, void 0, function* () {
                if (!notebook.id)
                    return;
                notebook.sections = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getSections).call(this, notebook, "notebooks");
                notebook.sectionGroups = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getSectionGroups).call(this, notebook, "sectionGroups");
            }));
        });
    }
}
exports.OneNoteClient = OneNoteClient;
_OneNoteClient_client = new WeakMap(), _OneNoteClient_reporter = new WeakMap(), _OneNoteClient_instances = new WeakSet(), _OneNoteClient_getSections = function _OneNoteClient_getSections(parent, parentType) {
    return __awaiter(this, void 0, void 0, function* () {
        let sections = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getAll).call(this, `/me/onenote/${parentType}/${parent.id}/sections`, "section", defaultProperties);
        return yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_processAll).call(this, sections, "section", (section) => __awaiter(this, void 0, void 0, function* () {
            if (!section.id)
                return;
            if (parentType === "notebooks")
                section.parentNotebook = __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getParent).call(this, parent);
            else if (parentType === "sectionGroups")
                section.parentSectionGroup = __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getParent).call(this, parent);
            section.pages = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getPages).call(this, section);
        }));
    });
}, _OneNoteClient_getSectionGroups = function _OneNoteClient_getSectionGroups(parent, parentType) {
    return __awaiter(this, void 0, void 0, function* () {
        let sectionGroups = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getAll).call(this, `/me/onenote/${parentType}/${parent.id}/sectionGroups`, "sectionGroup", defaultProperties);
        return yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_processAll).call(this, sectionGroups, "sectionGroup", (sectionGroup) => __awaiter(this, void 0, void 0, function* () {
            if (!sectionGroup.id)
                return;
            if (parentType === "notebooks")
                sectionGroup.parentNotebook = __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getParent).call(this, parent);
            else if (parentType === "sectionGroups")
                sectionGroup.parentSectionGroup = __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getParent).call(this, parent);
            sectionGroup.sections = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getSections).call(this, sectionGroup, "sectionGroups");
            sectionGroup.sectionGroups = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getSectionGroups).call(this, sectionGroup, "sectionGroups");
        }));
    });
}, _OneNoteClient_getPages = function _OneNoteClient_getPages(section) {
    return __awaiter(this, void 0, void 0, function* () {
        let pages = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getAll).call(this, `/me/onenote/sections/${section.id}/pages`, "page", [
            "id",
            "title",
            "createdDateTime",
            "lastModifiedDateTime",
            "level",
            "order",
            "userTags",
        ]);
        return yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_processAll).call(this, pages, "page", (page) => __awaiter(this, void 0, void 0, function* () {
            if (!page.id)
                return;
            page.parentSection = {
                parentSectionGroup: section.parentSectionGroup,
                parentNotebook: section.parentNotebook,
                id: section.id,
                displayName: section.displayName,
            };
            page.content = yield __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_getPageContent).call(this, page);
        }));
    });
}, _OneNoteClient_getPageContent = function _OneNoteClient_getPageContent(page) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const stream = (yield __classPrivateFieldGet(this, _OneNoteClient_client, "f")
                .api(`/me/onenote/pages/${page.id}/content`)
                .getStream());
            if (!stream)
                return null;
            const html = (yield convertStream(stream)).toString("utf8");
            return new content_1.Content(html, {
                attachmentResolver: (url) => __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_resolveDataUrl).call(this, url, page),
            });
        }
        catch (e) {
            const error = e;
            const pageRef = page.title || page.id;
            const notebook = (_b = (_a = page.parentSection) === null || _a === void 0 ? void 0 : _a.parentNotebook) === null || _b === void 0 ? void 0 : _b.displayName;
            const section = (_c = page.parentSection) === null || _c === void 0 ? void 0 : _c.displayName;
            let errorMessage = `Failed to get page content for page "${pageRef}" in ${notebook} > ${section}`;
            __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_handleError).call(this, error, errorMessage);
        }
        return null;
    });
}, _OneNoteClient_processAll = function _OneNoteClient_processAll(items, type, process) {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function* () {
        (_a = __classPrivateFieldGet(this, _OneNoteClient_reporter, "f")) === null || _a === void 0 ? void 0 : _a.report({
            op: "process",
            type,
            total: items.length,
            current: 0,
        });
        for (let i = 0; i < items.length; ++i) {
            const item = items[i];
            yield process(item);
            (_b = __classPrivateFieldGet(this, _OneNoteClient_reporter, "f")) === null || _b === void 0 ? void 0 : _b.report({
                op: "process",
                type,
                total: items.length,
                current: i + 1,
            });
        }
        return items;
    });
}, _OneNoteClient_getAll = function _OneNoteClient_getAll(url, type, properties) {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function* () {
        let items = [];
        let response = undefined;
        let skip = 0;
        let limit = 100;
        while (!response || !!response["@odata.nextLink"]) {
            (_a = __classPrivateFieldGet(this, _OneNoteClient_reporter, "f")) === null || _a === void 0 ? void 0 : _a.report({
                op: "fetch",
                type,
                total: skip + limit,
                current: skip,
            });
            response = (yield __classPrivateFieldGet(this, _OneNoteClient_client, "f")
                .api(url)
                .top(limit)
                .skip(skip)
                .select(properties)
                .get()
                .catch((e) => __awaiter(this, void 0, void 0, function* () {
                const error = e;
                let errorMessage = `Failed to get ${type}`;
                __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_handleError).call(this, error, errorMessage);
                return undefined;
            })));
            if (!response || !response.value)
                break;
            items.push(...response.value);
            skip += limit;
        }
        (_b = __classPrivateFieldGet(this, _OneNoteClient_reporter, "f")) === null || _b === void 0 ? void 0 : _b.report({
            op: "fetch",
            type,
            total: items.length,
            current: items.length,
        });
        return items;
    });
}, _OneNoteClient_resolveDataUrl = function _OneNoteClient_resolveDataUrl(url, page) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const stream = (yield __classPrivateFieldGet(this, _OneNoteClient_client, "f").api(url).getStream());
            if (!stream)
                return null;
            return yield convertStream(stream);
        }
        catch (e) {
            const error = e;
            const pageRef = page.title || page.id;
            const notebook = (_b = (_a = page.parentSection) === null || _a === void 0 ? void 0 : _a.parentNotebook) === null || _b === void 0 ? void 0 : _b.displayName;
            const section = (_c = page.parentSection) === null || _c === void 0 ? void 0 : _c.displayName;
            let errorMessage = `Failed to resolve attachment in page "${pageRef}" in ${notebook} > ${section}`;
            __classPrivateFieldGet(this, _OneNoteClient_instances, "m", _OneNoteClient_handleError).call(this, error, errorMessage);
        }
        return null;
    });
}, _OneNoteClient_handleError = function _OneNoteClient_handleError(e, message) {
    var _a;
    const error = e;
    let errorMessage = message;
    if (error.message)
        errorMessage += ` (original error: ${error.message}).`;
    if (error instanceof microsoft_graph_client_1.GraphError) {
        errorMessage += ` (Request failed with status code: ${error.statusCode}).`;
    }
    (_a = __classPrivateFieldGet(this, _OneNoteClient_reporter, "f")) === null || _a === void 0 ? void 0 : _a.error(new Error(errorMessage));
}, _OneNoteClient_getParent = function _OneNoteClient_getParent(parent) {
    return { id: parent.id, displayName: parent.displayName };
};
function convertStream(stream) {
    return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
        if (isWebStream(stream)) {
            const chunks = [];
            const reader = stream.getReader();
            yield reader
                .read()
                .then(function processText({ done, value }) {
                if (done) {
                    resolve(Buffer.concat(chunks));
                    return;
                }
                chunks.push(Buffer.from(value));
                return reader.read().then(processText);
            });
        }
        else {
            const chunks = [];
            stream.on("data", (chunk) => chunks.push(Buffer.from(chunk)));
            stream.on("error", (err) => reject(err));
            stream.on("end", () => resolve(Buffer.concat(chunks)));
        }
    }));
}
function isWebStream(stream) {
    return "ReadableStream" in globalThis && stream instanceof ReadableStream;
}
