"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.authenticate = void 0;
const msal_browser_1 = require("@azure/msal-browser");
const config_1 = require("./config");
let client;
function getClient(config) {
    if (!client)
        client = new msal_browser_1.PublicClientApplication({
            auth: {
                clientId: config.clientId,
                redirectUri: config.redirectUri,
            },
            cache: {
                cacheLocation: "localStorage",
                storeAuthStateInCookie: false,
                secureCookies: false,
            },
        });
    return client;
}
function authenticate(config) {
    return __awaiter(this, void 0, void 0, function* () {
        const client = getClient(config);
        const accounts = client.getAllAccounts();
        return yield client
            .acquireTokenSilent({
            scopes: config_1.SCOPES,
            account: accounts[0],
        })
            .catch(() => {
            if (!client)
                return null;
            return client.acquireTokenPopup({
                scopes: config_1.SCOPES,
            });
        });
    });
}
exports.authenticate = authenticate;
