/// <reference types="node" />
import { HTMLElement } from "node-html-parser";
export interface IElementHandler {
    process(type: string, element: HTMLElement): Promise<string | undefined>;
}
declare type AttachmentResolver = (url: string) => Promise<Buffer | null>;
declare type ContentOptions = {
    attachmentResolver: AttachmentResolver;
};
export declare class Content {
    #private;
    private readonly options;
    constructor(html: string, options: ContentOptions);
    transform(handler?: IElementHandler): Promise<string>;
    get raw(): string;
    toJSON(): string;
}
export {};
