export declare type GraphAPIResponse<T> = {
    ["@odata.nextLink"]?: string;
    ["@odata.context"]?: string;
    value?: T;
};
export declare type ItemType = "notebook" | "sectionGroup" | "section" | "page";
export declare type Op = "fetch" | "process";
export declare type ProgressPayload = {
    type: ItemType;
    op: Op;
    total: number;
    current: number;
};
export interface IProgressReporter {
    report: (payload: ProgressPayload) => void;
    error: (e: Error) => void;
}
